/*
 * Click nbfs://nbhost/SystemFileSystem/Templates/Licenses/license-default.txt to change this license
 * Click nbfs://nbhost/SystemFileSystem/Templates/GUIForms/JFrame.java to edit this template
 */
package vista;

import controlador.ListaEnlazada;
import controlador.tablaPersona;
import controlador.utiles.TipoOrdenacion;
import java.util.logging.Level;
import java.util.logging.Logger;
import javax.swing.JOptionPane;
import modelo.persona;

/**
 *
 * @author Ronald Cuenca
 */
public class ventana extends javax.swing.JFrame {

    ListaEnlazada<persona> lista1 = new ListaEnlazada<>();
    tablaPersona tp = new tablaPersona();

    /**
     * Creates new form ventana
     */
    public ventana() {
        initComponents();
        setLocationRelativeTo(null);
    }

    public void cargarTabla() {
        tp.setLista(lista1);
        jTable1.setModel(tp);
        jTable1.updateUI();
    }

    /**
     * This method is called from within the constructor to initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is always
     * regenerated by the Form Editor.
     */
    @SuppressWarnings("unchecked")
    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents() {

        jButton2 = new javax.swing.JButton();
        jScrollPane1 = new javax.swing.JScrollPane();
        jTable1 = new javax.swing.JTable();
        jLabel1 = new javax.swing.JLabel();
        jComboBox1 = new javax.swing.JComboBox<>();
        jLabel2 = new javax.swing.JLabel();
        jComboBox2 = new javax.swing.JComboBox<>();
        jButton1 = new javax.swing.JButton();
        jButton3 = new javax.swing.JButton();
        jLabel3 = new javax.swing.JLabel();
        jComboBox3 = new javax.swing.JComboBox<>();

        setDefaultCloseOperation(javax.swing.WindowConstants.EXIT_ON_CLOSE);

        jButton2.setText("Llenar");
        jButton2.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jButton2ActionPerformed(evt);
            }
        });

        jTable1.setModel(new javax.swing.table.DefaultTableModel(
            new Object [][] {
                {null, null, null, null},
                {null, null, null, null},
                {null, null, null, null},
                {null, null, null, null}
            },
            new String [] {
                "Title 1", "Title 2", "Title 3", "Title 4"
            }
        ));
        jScrollPane1.setViewportView(jTable1);

        jLabel1.setText("Ordenar:");

        jComboBox1.setModel(new javax.swing.DefaultComboBoxModel<>(new String[] { "ASCENDENTE", "DESCENDENTE" }));

        jLabel2.setText("Atributo:");

        jComboBox2.setModel(new javax.swing.DefaultComboBoxModel<>(new String[] { "ID", "Nombre", "Edad" }));

        jButton1.setText("Ordenar");
        jButton1.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jButton1ActionPerformed(evt);
            }
        });

        jButton3.setText("Vaciar");
        jButton3.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jButton3ActionPerformed(evt);
            }
        });

        jLabel3.setText("Método:");

        jComboBox3.setModel(new javax.swing.DefaultComboBoxModel<>(new String[] { "Shell", "QuickSort" }));

        javax.swing.GroupLayout layout = new javax.swing.GroupLayout(getContentPane());
        getContentPane().setLayout(layout);
        layout.setHorizontalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(layout.createSequentialGroup()
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addGroup(layout.createSequentialGroup()
                        .addGap(20, 20, 20)
                        .addComponent(jScrollPane1, javax.swing.GroupLayout.PREFERRED_SIZE, 329, javax.swing.GroupLayout.PREFERRED_SIZE))
                    .addGroup(layout.createSequentialGroup()
                        .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                            .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING, false)
                                .addGroup(layout.createSequentialGroup()
                                    .addContainerGap()
                                    .addComponent(jLabel1)
                                    .addGap(18, 18, 18)
                                    .addComponent(jComboBox1, javax.swing.GroupLayout.PREFERRED_SIZE, 108, javax.swing.GroupLayout.PREFERRED_SIZE))
                                .addGroup(layout.createSequentialGroup()
                                    .addContainerGap()
                                    .addComponent(jLabel3)
                                    .addGap(18, 18, 18)
                                    .addComponent(jComboBox3, 0, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)))
                            .addGroup(layout.createSequentialGroup()
                                .addGap(53, 53, 53)
                                .addComponent(jButton2)))
                        .addGap(31, 31, 31)
                        .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                            .addComponent(jButton3)
                            .addComponent(jButton1)
                            .addGroup(layout.createSequentialGroup()
                                .addComponent(jLabel2)
                                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.UNRELATED)
                                .addComponent(jComboBox2, javax.swing.GroupLayout.PREFERRED_SIZE, 76, javax.swing.GroupLayout.PREFERRED_SIZE)))))
                .addContainerGap(22, Short.MAX_VALUE))
        );
        layout.setVerticalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(layout.createSequentialGroup()
                .addContainerGap()
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(jButton2)
                    .addComponent(jButton3))
                .addGap(42, 42, 42)
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.TRAILING)
                    .addGroup(layout.createSequentialGroup()
                        .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                            .addComponent(jLabel1)
                            .addComponent(jComboBox1, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                            .addComponent(jLabel2)
                            .addComponent(jComboBox2, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))
                        .addGap(18, 18, 18)
                        .addComponent(jButton1))
                    .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                        .addComponent(jLabel3)
                        .addComponent(jComboBox3, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)))
                .addGap(12, 12, 12)
                .addComponent(jScrollPane1, javax.swing.GroupLayout.PREFERRED_SIZE, 275, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addContainerGap(25, Short.MAX_VALUE))
        );

        pack();
    }// </editor-fold>//GEN-END:initComponents

    private void jButton2ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jButton2ActionPerformed
        lista1 = lista1.llenarLista();
        cargarTabla();
    }//GEN-LAST:event_jButton2ActionPerformed

    private void jButton1ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jButton1ActionPerformed
        // TODO add your handling code here:
        if (jComboBox3.getSelectedItem().equals("Shell")) {
            if (jComboBox1.getSelectedItem().equals("ASCENDENTE") && jComboBox2.getSelectedItem().equals("ID")) {
                try {
                    long inicio = System.currentTimeMillis();
                    lista1.shell("IDPersona", TipoOrdenacion.ASCENDENTE);
                    cargarTabla();
                    long fin = System.currentTimeMillis();
                    JOptionPane.showMessageDialog(null, "Tiempo total: " + ((double) (fin - inicio) / 1000) + "s");
                } catch (Exception e) {
                    System.out.println(e);
                }
            }
            if (jComboBox1.getSelectedItem().equals("DESCENDENTE") && jComboBox2.getSelectedItem().equals("ID")) {
                try {
                    long inicio = System.currentTimeMillis();
                    lista1.shell("IDPersona", TipoOrdenacion.DESCENDENTE);
                    cargarTabla();
                    long fin = System.currentTimeMillis();
                    JOptionPane.showMessageDialog(null, "Tiempo total: " + ((double) (fin - inicio) / 1000) + "s");
                } catch (Exception e) {
                    System.out.println(e);
                }
            }
            if (jComboBox1.getSelectedItem().equals("ASCENDENTE") && jComboBox2.getSelectedItem().equals("Nombre")) {
                try {
                    long inicio = System.currentTimeMillis();
                    lista1.shell("nombre", TipoOrdenacion.ASCENDENTE);
                    cargarTabla();
                    long fin = System.currentTimeMillis();
                    JOptionPane.showMessageDialog(null, "Tiempo total: " + ((double) (fin - inicio) / 1000) + "s");
                } catch (Exception e) {
                    System.out.println(e);
                }
            }
            if (jComboBox1.getSelectedItem().equals("DESCENDENTE") && jComboBox2.getSelectedItem().equals("Nombre")) {
                try {
                    long inicio = System.currentTimeMillis();
                    lista1.shell("nombre", TipoOrdenacion.DESCENDENTE);
                    cargarTabla();
                    long fin = System.currentTimeMillis();
                    JOptionPane.showMessageDialog(null, "Tiempo total: " + ((double) (fin - inicio) / 1000) + "s");
                } catch (Exception e) {
                    System.out.println(e);
                }
            }
            if (jComboBox1.getSelectedItem().equals("ASCENDENTE") && jComboBox2.getSelectedItem().equals("Edad")) {
                try {
                    long inicio = System.currentTimeMillis();
                    lista1.shell("edad", TipoOrdenacion.ASCENDENTE);
                    cargarTabla();
                    long fin = System.currentTimeMillis();
                    JOptionPane.showMessageDialog(null, "Tiempo total: " + ((double) (fin - inicio) / 1000) + "s");
                } catch (Exception e) {
                    System.out.println(e);
                }
            }
            if (jComboBox1.getSelectedItem().equals("DESCENDENTE") && jComboBox2.getSelectedItem().equals("Edad")) {
                try {
                    long inicio = System.currentTimeMillis();
                    lista1.shell("edad", TipoOrdenacion.DESCENDENTE);
                    cargarTabla();
                    long fin = System.currentTimeMillis();
                    JOptionPane.showMessageDialog(null, "Tiempo total: " + ((double) (fin - inicio) / 1000) + "s");
                } catch (Exception e) {
                    System.out.println(e);
                }
            }
        }else if (jComboBox3.getSelectedItem().equals("QuickSort")) {
            if (jComboBox1.getSelectedItem().equals("ASCENDENTE") && jComboBox2.getSelectedItem().equals("ID")) {
                try {
                    long inicio = System.currentTimeMillis();
                    lista1.QuickSortID(lista1, 0, lista1.getSize()-1, TipoOrdenacion.ASCENDENTE);
                    cargarTabla();
                    long fin = System.currentTimeMillis();
                    JOptionPane.showMessageDialog(null, "Tiempo total: " + ((double) (fin - inicio) / 1000) + "s");
                } catch (Exception e) {
                    System.out.println(e);
                }
            }
            if (jComboBox1.getSelectedItem().equals("DESCENDENTE") && jComboBox2.getSelectedItem().equals("ID")) {
                try {
                    long inicio = System.currentTimeMillis();
                    lista1.QuickSortID(lista1, 0, lista1.getSize()-1, TipoOrdenacion.DESCENDENTE);
                    cargarTabla();
                    long fin = System.currentTimeMillis();
                    JOptionPane.showMessageDialog(null, "Tiempo total: " + ((double) (fin - inicio) / 1000) + "s");
                } catch (Exception e) {
                    System.out.println(e);
                }
            }
            if (jComboBox1.getSelectedItem().equals("ASCENDENTE") && jComboBox2.getSelectedItem().equals("Nombre")) {
                try {
                    long inicio = System.currentTimeMillis();
                    lista1.QuickSortNombre(lista1, 0, lista1.getSize()-1, TipoOrdenacion.ASCENDENTE);
                    cargarTabla();
                    long fin = System.currentTimeMillis();
                    JOptionPane.showMessageDialog(null, "Tiempo total: " + ((double) (fin - inicio) / 1000) + "s");
                } catch (Exception e) {
                    System.out.println(e);
                }
            }
            if (jComboBox1.getSelectedItem().equals("DESCENDENTE") && jComboBox2.getSelectedItem().equals("Nombre")) {
                try {
                    long inicio = System.currentTimeMillis();
                    lista1.QuickSortNombre(lista1, 0, lista1.getSize()-1, TipoOrdenacion.DESCENDENTE);
                    cargarTabla();
                    long fin = System.currentTimeMillis();
                    JOptionPane.showMessageDialog(null, "Tiempo total: " + ((double) (fin - inicio) / 1000) + "s");
                } catch (Exception e) {
                    System.out.println(e);
                }
            }
            if (jComboBox1.getSelectedItem().equals("ASCENDENTE") && jComboBox2.getSelectedItem().equals("Edad")) {
                try {
                    long inicio = System.currentTimeMillis();
                    ListaEnlazada<persona> auxP = null;
                    auxP=lista1;
                    auxP.QuickSortedad(auxP, 0, auxP.getSize()-1,TipoOrdenacion.ASCENDENTE);
                    cargarTabla();
                    long fin = System.currentTimeMillis();
                    JOptionPane.showMessageDialog(null, "Tiempo total: " + ((double) (fin - inicio) / 1000) + "s");
                } catch (Exception e) {
                    System.out.println(e);
                }
            }
            if (jComboBox1.getSelectedItem().equals("DESCENDENTE") && jComboBox2.getSelectedItem().equals("Edad")) {
                try {
                    long inicio = System.currentTimeMillis();
                    ListaEnlazada<persona> auxP2 = null;
                    auxP2=lista1;
                    auxP2.QuickSortedad(auxP2, 0, auxP2.getSize()-1,TipoOrdenacion.DESCENDENTE);
                    cargarTabla();
                    long fin = System.currentTimeMillis();
                    JOptionPane.showMessageDialog(null, "Tiempo total: " + ((double) (fin - inicio) / 1000) + "s");
                } catch (Exception e) {
                    System.out.println(e);
                }
            }
        }

    }//GEN-LAST:event_jButton1ActionPerformed

    private void jButton3ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jButton3ActionPerformed
        // TODO add your handling code here:
        lista1.vaciar();
        cargarTabla();
    }//GEN-LAST:event_jButton3ActionPerformed

    /**
     * @param args the command line arguments
     */
    public static void main(String args[]) {
        /* Set the Nimbus look and feel */
        //<editor-fold defaultstate="collapsed" desc=" Look and feel setting code (optional) ">
        /* If Nimbus (introduced in Java SE 6) is not available, stay with the default look and feel.
         * For details see http://download.oracle.com/javase/tutorial/uiswing/lookandfeel/plaf.html 
         */
        try {
            for (javax.swing.UIManager.LookAndFeelInfo info : javax.swing.UIManager.getInstalledLookAndFeels()) {
                if ("Nimbus".equals(info.getName())) {
                    javax.swing.UIManager.setLookAndFeel(info.getClassName());
                    break;
                }
            }
        } catch (ClassNotFoundException ex) {
            java.util.logging.Logger.getLogger(ventana.class.getName()).log(java.util.logging.Level.SEVERE, null, ex);
        } catch (InstantiationException ex) {
            java.util.logging.Logger.getLogger(ventana.class.getName()).log(java.util.logging.Level.SEVERE, null, ex);
        } catch (IllegalAccessException ex) {
            java.util.logging.Logger.getLogger(ventana.class.getName()).log(java.util.logging.Level.SEVERE, null, ex);
        } catch (javax.swing.UnsupportedLookAndFeelException ex) {
            java.util.logging.Logger.getLogger(ventana.class.getName()).log(java.util.logging.Level.SEVERE, null, ex);
        }
        //</editor-fold>

        /* Create and display the form */
        java.awt.EventQueue.invokeLater(new Runnable() {
            public void run() {
                new ventana().setVisible(true);
            }
        });
    }


    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JButton jButton1;
    private javax.swing.JButton jButton2;
    private javax.swing.JButton jButton3;
    private javax.swing.JComboBox<String> jComboBox1;
    private javax.swing.JComboBox<String> jComboBox2;
    private javax.swing.JComboBox<String> jComboBox3;
    private javax.swing.JLabel jLabel1;
    private javax.swing.JLabel jLabel2;
    private javax.swing.JLabel jLabel3;
    private javax.swing.JScrollPane jScrollPane1;
    private javax.swing.JTable jTable1;
    // End of variables declaration//GEN-END:variables
}
